function Create(self)
	if self.Magazine then --have mag
		self.ammo = self.Magazine.RoundCount --have ammo
	else--no mag
		self.ammo = 0 --no ammo
	end
	
	self.laserTimer = Timer();
	self.particleTable = {};

	self.projectileVel = 70;
	self.maxTrajectoryPars = 10;
	
	
end

function Update(self)
	if self.Magazine then --have mag
		self.Frame = 1;
		if self.ammo > self.Magazine.RoundCount then
			-- bullets are missing from the magazine so the gun must have been fired
			
			local Parent = MovableMan:GetMOFromID(self.RootID) --get thing holding gun and store as parent
			--local BulletVel = self.Vel + self:RotateOffset(Vector(170,RangeRand(-3,3))) --set bullet velocity adnd direction
			
			-- bullets
			if self.HFlipped == false then
				self.negativeNum = 1;
			else
				self.negativeNum = -1;
			end
			
			local Target = Vector(0,0);
			if SceneMan:CastNotMaterialRay(self.Pos, Vector(700*self.negativeNum,0):RadRotate(self.RotAngle), 0, Target, 0, false) == true then
				local dist = math.sqrt((Target.X-self.Pos.X)^2+(Target.Y-self.Pos.Y)^2);
				print(dist);
				for i = 2, math.floor(dist/10), 1 do
					local explosive = CreateMOPixel("Impluse Laser Particle Glow");
					explosive.Pos = self.Pos+Vector(10*i*self.negativeNum,0):RadRotate(self.RotAngle);
					explosive.Vel = Vector(0,0);
					MovableMan:AddParticle(explosive)
					--explosive:GibThis();
					local Effect = CreateMOPixel("Impluse Laser Particle Small");
					Effect.Pos = self.Pos+Vector(10*i*self.negativeNum,0):RadRotate(self.RotAngle);
					Effect.Vel = Vector(20*self.negativeNum,0):RadRotate(self.RotAngle);
					Effect:SetWhichMOToNotHit(Parent, 0.1)
					if MovableMan:IsActor(Parent) then
						Effect.Team = ToActor(Parent).Team;
						Effect.IgnoresTeamHits = true;
					end
					MovableMan:AddParticle(Effect)
				end
			else
				for i = 2, 70, 1 do
					local explosive = CreateMOPixel("Impluse Laser Particle Glow");
					explosive.Pos = self.Pos+Vector(10*i*self.negativeNum,0):RadRotate(self.RotAngle);
					explosive.Vel = Vector(0,0);
					MovableMan:AddParticle(explosive)
					--explosive:GibThis();
					local Effect = CreateMOPixel("Impluse Laser Particle Small");
					Effect.Pos = self.Pos+Vector(10*i*self.negativeNum,0):RadRotate(self.RotAngle);
					Effect.Vel = Vector(20*self.negativeNum,0):RadRotate(self.RotAngle);
					Effect:SetWhichMOToNotHit(Parent, 0.1)
					if MovableMan:IsActor(Parent) then
						Effect.Team = ToActor(Parent).Team;
						Effect.IgnoresTeamHits = true;
					end
					MovableMan:AddParticle(Effect)
				end
			end
			
			
			--[[
			local Effect = CreateMOSRotating("Shot Coalition Heavy Sniper", "Coalition.rte")
			if Effect then
				Effect.Vel = BulletVel --set velocity
				Effect.Pos = self.MuzzlePos --fire from muzzle
				Effect:SetWhichMOToNotHit(Parent, 0.1) --don't hit gun owner
				MovableMan:AddParticle(Effect) --add the bullet
				  
			end
			
			for i = 1, 4 do --4 more shots
				Effect = CreateMOPixel("Particle Coalition Sniper Heavy", "Coalition.rte") --more of the same
				if Effect then
					Effect.Vel = BulletVel
					Effect.Pos = self.MuzzlePos
					Effect:SetWhichMOToNotHit(Parent, 0.1)
					MovableMan:AddParticle(Effect)
				end
			end
			
			-- forward
			for i = 1, 4 do
				Effect = CreateMOSParticle("Side Thruster Blast Ball 1", "Base.rte")
				if Effect then
					Effect.Vel = self.Vel + self:RotateOffset(Vector(RangeRand(6,9),RangeRand(-3,3)))
					Effect.Pos = self.MuzzlePos
					MovableMan:AddParticle(Effect)
				end
			end
			
			-- up
			for i = 1, 5 do
				Effect = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
				if Effect then
					Effect.Vel = self.Vel - self:RotateOffset(Vector(RangeRand(-2,2), RangeRand(7,11)))
					Effect.Pos = self.MuzzlePos
					MovableMan:AddParticle(Effect)
				end
			end
			
			-- down
			for i = 1, 5 do
				Effect = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
				if Effect then
					Effect.Vel = self.Vel + self:RotateOffset(Vector(RangeRand(-2,2), RangeRand(7,11)))
					Effect.Pos = self.MuzzlePos
					MovableMan:AddParticle(Effect)
				end
			end
			]]
		end
		
		-- update the ammo counter so this script can't spawn bullets until the gun has been fired again
		self.ammo = self.Magazine.RoundCount
	else
		self.Frame = 1;
	end
	print(self.Frame);
	
	
	
	
	if self.laserTimer:IsPastSimMS(25) then
		self.laserTimer:Reset();

		for i = 1, #self.particleTable do
			if MovableMan:IsParticle(self.particleTable[i]) then
				self.particleTable[i].ToDelete = true;
			end
		end
		self.particleTable = {};

		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) and ToActor(actor):IsPlayerControlled() and ToActor(actor):GetController():IsState(Controller.AIM_SHARP) then
			local actor = ToActor(actor);
			self.guideParPos = self.MuzzlePos;
			self.guideParVel = Vector(self.projectileVel,0):RadRotate(actor:GetAimAngle(true));
			for i = 1, self.maxTrajectoryPars do
				if SceneMan:GetTerrMatter(self.guideParPos.X,self.guideParPos.Y) == 0 then
					--self.guideParVel = self.guideParVel + Vector((SceneMan.GlobalAcc.X/FrameMan.PPM),(SceneMan.GlobalAcc.Y/FrameMan.PPM));
					self.guideParPos = self.guideParPos + self.guideParVel;
					if SceneMan.SceneWrapsX == true then
						if self.guideParPos.X > SceneMan.SceneWidth then
							self.guideParPos = Vector(self.guideParPos.X - SceneMan.SceneWidth,self.guideParPos.Y);
						elseif self.guideParPos.X < 0 then
							self.guideParPos = Vector(SceneMan.SceneWidth + self.guideParPos.X,self.guideParPos.Y);
						end
					end
					local laserParticle = CreateMOSParticle("Coalition Breaker Grenade Launcher Guide Particle");
					laserParticle.Pos = self.guideParPos;
					MovableMan:AddParticle(laserParticle);
					self.particleTable[#self.particleTable+1] = laserParticle;
				else
					break;
				end
			end
		end
	end
end
