function Create(self)

	self.ejectedShell = false;

	self.reloaded = false;
	self.ammoCounter = 0;
	self.bulletTableA = {};
	self.bulletTableB = {};
	self.maxActiveBullets = 30;

end

function Update(self)

	if self.Magazine ~= nil then
		self.ejectedShell = false;
	else
		if self.ejectedShell == false then
			self.ejectedShell = true;
			if self.HFlipped == false then
				self.negativeNum = 1;
			else
				self.negativeNum = -1;
			end
			for i = 1, 6 do
				local shell = CreateMOSParticle("Casing");
				shell.Pos = self.Pos;
				shell.Vel = Vector(math.random()*(-3)*self.negativeNum,0):RadRotate(self.RotAngle):DegRotate((math.random()*32)-16);
				MovableMan:AddParticle(shell);
			end
		end
	end

	if self.Magazine ~= nil then
		if self.reloaded == false then
			self.reloaded = true;
			self.ammoCounter = self.Magazine.RoundCount;
		else
			if self.ammoCounter ~= self.Magazine.RoundCount then

				if self.HFlipped == false then
					self.negativeNum = 1;
				else
					self.negativeNum = -1;
				end

				local Parent = MovableMan:GetMOFromID(self.RootID)
				
				local bullet = CreateMOPixel("Bullet Chronos", "RFS.rte");
				bullet.Pos = self.MuzzlePos;
				bullet.Vel = Vector(0.9*self.negativeNum,0):RadRotate(self.RotAngle);
				bullet:SetWhichMOToNotHit(Parent, 0.1)
				if MovableMan:IsActor(Parent) then
					bullet.Team = ToActor(Parent).Team;
					bullet.IgnoresTeamHits = true;
				end

				local actor = MovableMan:GetMOFromID(self.RootID);
				if MovableMan:IsActor(actor) and ToActor(actor):IsPlayerControlled() then
					if self.bulletTableA[self.maxActiveBullets] ~= nil then
						self.bulletTableA[self.maxActiveBullets].Sharpness = 2;
					end
					for i = 1, self.maxActiveBullets do
						self.bulletTableB[i+1] = self.bulletTableA[i];
					end
					self.bulletTableA = {};
					for i = 1, self.maxActiveBullets do
						self.bulletTableA[i] = self.bulletTableB[i];
					end
					self.bulletTableB = {};
					self.bulletTableA[1] = bullet;
					bullet.Sharpness = 0; --reset sharpness
				else
					bullet.Sharpness = 3; --set AI controlled state
				end

				MovableMan:AddParticle(bullet);

			end
			self.ammoCounter = self.Magazine.RoundCount;
		end
	else
		self.reloaded = false;
	end

	if self.Sharpness == 1 then --if detonate state
		self.Sharpness = 0; --reset sharpness
		for i = 1, #self.bulletTableA do
			if MovableMan:IsParticle(self.bulletTableA[i]) then
				self.bulletTableA[i].Sharpness = 2; --set nade detonate state
			end
		end
		self.bulletTableA = {};
	elseif self.Sharpness == 2 then --if delete state
		self.Sharpness = 0; --reset sharpness
		for i = 1, #self.bulletTableA do
			if MovableMan:IsParticle(self.bulletTableA[i]) then
				self.bulletTableA[i].Sharpness = 1; --set nade delete state
			end
		end
		self.bulletTableA = {};
	end

end

function Destroy(self)

	for i = 1, #self.bulletTableA do
		if MovableMan:IsParticle(self.bulletTableA[i]) then
			self.bulletTableA[i].Sharpness = 1;
		end
	end

end